#include <Agents/Agent.hpp>
#include <Environment/PictureEnvironment.hpp>

PullPaintAgent::PullPaintAgent(PictureEnvironment* iEnvironment, int iDotSize, int iMoveSize) :
	RepaintAgent(iEnvironment, iDotSize, iMoveSize)
{
	int vWidth = fEnvironment->getWidth();
	int vHeight = fEnvironment->getHeight();

	fXPos = (((double)rand() / RAND_MAX) * vWidth);
	fYPos = (((double)rand() / RAND_MAX) * vHeight);

	fColor = sf::Color(fEnvironment->getCell(fXPos, fYPos));
}

void PullPaintAgent::move()
{
	double vRand = rand() % (fMoveSize + 1);
	fXPos += vRand - fMoveSize / 2;
	vRand = rand() % (fMoveSize + 1);
	fYPos += vRand - fMoveSize / 2;
}

void PullPaintAgent::loop()
{
	move();
	this->paint();
}
